package com.yonge.cooleshow.biz.dal.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.yonge.cooleshow.biz.dal.dao.SysUserContractRecordDao;
import com.yonge.cooleshow.biz.dal.entity.SysUserContractRecord;
import com.yonge.cooleshow.biz.dal.enums.ContractTypeEnum;
import com.yonge.cooleshow.biz.dal.service.ContractTemplateService;
import com.yonge.cooleshow.biz.dal.service.SysUserContractRecordService;
import com.yonge.cooleshow.common.entity.HttpResponseResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 用户协议记录表-一个用户一种协议一个版本一条记录(SysUserContractRecord)表服务实现类
 *
 * @author hgw
 * @since 2022-05-07 15:04:06
 */
@Service("sysUserContractRecordService")
public class SysUserContractRecordServiceImpl extends ServiceImpl<SysUserContractRecordDao, SysUserContractRecord> implements SysUserContractRecordService {

    private final static Logger log = LoggerFactory.getLogger(SysUserContractRecordServiceImpl.class);

    @Autowired
    private ContractTemplateService contractTemplateService;

    @Override
    public SysUserContractRecordDao getDao() {
        return this.baseMapper;
    }

    @Override
    public HttpResponseResult<Boolean> checkContractSign(Long userId, ContractTypeEnum contractType) {
        return HttpResponseResult.succeed(getDao().checkContractSign(userId, contractType.getCode()));
    }

    /**
     * 校验当前用户签署的协议是否是最新版本
     */
    public void checkContractRecord(Long userId, String type) {
        //根据人员id及协议类型查询最新协议记录
        //查询对应类型的最新的协议
        //对比当前类型及人员id的协议版本
        //如果不是最新版本，则返回false
    }

}

