package com.yonge.cooleshow.classroom;

import com.spring4all.swagger.EnableSwagger2Doc;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;

@SpringBootApplication
@EnableDiscoveryClient
@EnableFeignClients("com.yonge.cooleshow")
@MapperScan(basePackages = {"com.yonge.cooleshow.biz.dal.dao", "com.yonge.toolset.payment.core.dao"})
@ComponentScan(basePackages = {
        "com.yonge.cooleshow.classroom", "com.yonge.cooleshow.auth", "com.yonge.cooleshow.biz",
        "com.yonge.cooleshow.common", "com.yonge.cooleshow.common.security",
        "com.yonge.toolset.log", "com.yonge.toolset.thirdparty", "com.yonge.toolset.payment"
})
@Configuration
@EnableSwagger2Doc
public class ClassroomApplication {
    public static void main(String[] args) {
        SpringApplication.run(ClassroomApplication.class, args);
    }

}
